****************************************************************
* Program MDXPICK.PRG - Allows user to select an mdx
*  tag from a list.
* Adapted from "Developing dBASE IV Applications:
*  Programming With the dBASE Template Language"
*  by Tony Lima (Addison-Wesley, 1989).
* Copyright, 1989, 1990, Tony Lima
* May be freely used and distributed as long as this entire
*  header remains intact.
* Thanks to Judy Maske for valuable editing assistance!
****************************************************************
* Must have a database with a production index file in use
*  before this section of code.
      IF TYPE("TAGLIST[1]") = "U"
        DECLARE TAGLIST[47],KEYLIST[47]                                                 
        ln_keyno = 1                                                                    
        lc_order = TRIM(ORDER())                                                        
        DO WHILE LEN(TRIM(TAG(ln_keyno))) <> 0                                          
          TAGLIST[ln_keyno] = TAG(ln_keyno)                                             
          KEYLIST[ln_keyno] = KEY(ln_keyno)                                             
          IF TRIM(TAGLIST[ln_keyno]) = TRIM(ORDER())                                    
            ln_ordno = ln_keyno                                                         
          ENDIF && TRIM(TAGLIST[ln_keyno]) = TRIM(ORDER())                              
          ln_keyno = ln_keyno + 1                                                       
        ENDDO  &&  TAG(ln_keyno) <> ""                                                  
        ln_maxkey = ln_keyno - 1                                                        
      ENDIF && TYPE("TAGLIST[1]") = "U"
      @ 01,20 SAY "Select an index key to use for this report."                       
      ln_keyno = 1                                                                    
      ll_break = .T.                                                                  
      DO WHILE ln_keyno <= ln_maxkey                                                  
        DO CASE                                                                       
         CASE ln_keyno <= 16
          @ 02,04 SAY "Index Tag"
          @ 02,16 SAY "Key"                                                           
          IF TRIM(TAGLIST[ln_keyno]) = lc_order                                       
            @ ln_keyno+2,00 SAY STR(ln_keyno,2)+".*"+TAGLIST[ln_keyno]+;
              SPACE(10-LEN(TAGLIST[ln_keyno]))+"  "+;
              SUBSTR(KEYLIST[ln_keyno],1,11)                                          
           ELSE                                                                       
            @ ln_keyno+2,00 SAY STR(ln_keyno,2)+". "+TAGLIST[ln_keyno]+;
              SPACE(10-LEN(TAGLIST[ln_keyno]))+"  "+;
              SUBSTR(KEYLIST[ln_keyno],1,11)                                          
          ENDIF && TAG(ln_keyno) = lc_order                                           
         CASE ln_keyno <= 32                                                          
          @ 02,30 SAY "Index Tag"                                                     
          @ 02,42 SAY "Key"                                                           
          IF TRIM(TAGLIST[ln_keyno]) = lc_order                                       
            @ ln_keyno-14,26 SAY STR(ln_keyno,2)+".*"+TAGLIST[ln_keyno]+;
              SPACE(10-LEN(TAGLIST[ln_keyno]))+"  "+;
              SUBSTR(KEYLIST[ln_keyno],1,11)                                          
           ELSE                                                                       
            @ ln_keyno-14,26 SAY STR(ln_keyno,2)+". "+TAGLIST[ln_keyno]+;
              SPACE(10-LEN(TAGLIST[ln_keyno]))+"  "+;
              SUBSTR(KEYLIST[ln_keyno],1,11)                                          
          ENDIF && TAG(ln_keyno) = lc_order                                           
         CASE ln_keyno <= 47                                                          
          @ 02,56 SAY "Index Tag"                                                     
          @ 02,68 SAY "Key"                                                           
          IF TRIM(TAGLIST[ln_keyno]) = lc_order                                       
            @ ln_keyno-30,52 SAY STR(ln_keyno,2)+".*"+TAGLIST[ln_keyno]+;
              SPACE(10-LEN(TAGLIST[ln_keyno]))+"  "+;
              SUBSTR(KEYLIST[ln_keyno],1,11)                                          
           ELSE                                                                       
            @ ln_keyno-30,52 SAY STR(ln_keyno,2)+". "+TAGLIST[ln_keyno]+;             
              SPACE(10-LEN(TAGLIST[ln_keyno]))+"  "+;                                 
              SUBSTR(KEYLIST[ln_keyno],1,11)                                          
          ENDIF && ORDER(ln_keyno) = lc_order                                         
        ENDCASE                                                                       
      ln_keyno = ln_keyno + 1                                                         
      ENDDO && WHILE ln_keyno <= ln_maxkey                                            
      lc_choice = IIF(LEN(STR(ln_ordno))=1,"0"+STR(ln_ordno,1),STR(ln_ordno,2))       
      DO WHILE ln_keyno > ln_maxkey                                                   
        @ 19,23 SAY "Which index? " GET lc_choice PICTURE '#9' ;                      
          DEFAULT lc_order ;
          MESSAGE "Current tag is "+TRIM(TAGLIST[ln_ordno])+;
          " with key "+TRIM(KEYLIST[ln_ordno])+;
          ". Be sure to enter leading blank."
        READ                                                                          
        ln_keyno = VAL(lc_choice)                                                     
      ENDDO                                                                           
      SET ORDER TO TAG &TAGLIST[ln_keyno]
* EOP:  MDXPICK.PRG]

